#!/usr/bin/env node
/**
 * @ClassName xsyLog
 * @Description 日志管理模块
 * @Author wangtx@xiaoshouyi.com
 * @Date 2019/4/11 18:33
 **/

const log4js = require('log4js');
const path = require('path');

const logfile = path.join(path.resolve(__dirname), '../logs');

log4js.configure({
    "appenders": {
        // "console": {
        //     "type": "console"
        // },
        "info": {
            "type": "dateFile",
            "filename": logfile + "/xsy-info",
            "encoding": "utf-8",
            "pattern": "yyyy-MM-dd.log",
            "maxLogSize": 10000000,
            "alwaysIncludePattern": true,
            "layout": {
                "type": "pattern",
                "pattern": "[%d{ISO8601}][%5p  %z  %c] %m"
            },
            "compress": true
        },
        "maxInfo": {
            "type": "logLevelFilter",
            "appender": "info",
            "level": "debug",
            "maxLevel": "error"
        },
        "error": {
            "type": "dateFile",
            "filename": logfile + "/xsy-error",
            "pattern": "yyyy-MM-dd.log",
            "maxLogSize": 10000000,
            "encoding": "utf-8",
            "alwaysIncludePattern": true,
            "layout": {
                "type": "pattern",
                "pattern": "[%d{ISO8601}][%5p  %z  %c] %m"
            },
            "compress": true
        },
        "minError": {
            "type": "logLevelFilter",
            "appender": "error",
            "level": "error"
        }
    },
    "categories": {
        "default": {
            "appenders": [
                // "console", console不打印日志信息
                "maxInfo",
                "minError"
            ],
            "level": "all"
        }
    }
});
// , maxLogSize: 1024, backups:4

/**
 *
 * @param name name要有为标识，最好以路径为准
 * @returns {*}
 */
exports.logger=function(name){
    var logger = log4js.getLogger(name);
    return logger;
};
