#!/usr/bin/env node
/**
 * @ClassName index
 * @Description TODO
 * @Author wangtx@xiaoshouyi.com
 * @Date 2019/4/10 18:02
 **/
const logger = require('../../core/xsyLog').logger('module_user');
const xsyRequest = require('../../core/xsyRequest');
const loginUtils = require('../../utils/loginUtils');
const environmentUtils = require('../../utils/environmentUtils');
const fs = require("fs");
const path = require("path");
const inquirer = require('inquirer');
const colors = require('colors');

function add() {
    loginUtils.login();
}


function reLogin() {
    loginUtils.reLogin(function () {
        console.log("Success".green);
    })
}

function remove() {
    environmentUtils.getAllName(function (names) {
        if (names !== null && names !== undefined && names.length > 0) {
            const promptList = [{
                type: 'list',
                message: 'Please select one config name:',
                name: 'configName',
                choices: names
            }];
            inquirer.prompt(promptList).then(answers => {
                environmentUtils.removeEnvironment(answers.configName, function (res) {
                    if (res) {
                        console.log("Success".green);
                    }
                })
            })
        }
    })
}

function change() {
    environmentUtils.getAllName(function (names) {
        if (names !== null && names !== undefined && names.length > 0) {
            const promptList = [{
                type: 'list',
                message: 'Please select one config name:',
                name: 'configName',
                choices: names
            }];
            inquirer.prompt(promptList).then(answers => {
                environmentUtils.changeCurrent(answers.configName, function (res) {
                    if (res) {
                        console.log("Success".green);
                    }
                })
            })
        }
    })
}

function list() {
    environmentUtils.getAllName(function (names) {
        if (names !== null && names !== undefined && names.length > 0) {
            names.forEach(function (value, index) {
                console.log((" (" + (index + 1) + ") " + value).green);
            })
        }
    })
}

function current() {
    environmentUtils.getCurrentName(function (currentName) {
        if (currentName !== null && currentName !== undefined && currentName.trim() !== "") {
            console.log(currentName.green);
        } else {
            console.log("current config is null!".red);
        }
    })
}

/**
 * 退出当前登录的用户
 */
function logout() {
    environmentUtils.getCurrentName(function (currentName) {
        if (currentName !== null && currentName !== undefined && currentName.trim() !== "") {
            environmentUtils.removeEnvironment(currentName,function () {
            })
        }
    })
}

/**
 * 通过获取当前系统变量的token来判断是否登录
 * @param callback
 */
function isLogin(callback) {
    environmentUtils.getCurrentToken(function (token) {
        if (token === null || token === undefined || token.trim() === "") {
            callback(false)
        } else {
            callback(true)
        }
    })
}

exports.isLogin = isLogin;
exports.logout = logout;
exports.add = add;
exports.remove = remove;
exports.change = change;
exports.list = list;
exports.current = current;
exports.reLogin = reLogin;
