#!/usr/bin/env node
/**
 * @ClassName update
 * @Description TODO
 * @Author wangtx@xiaoshouyi.com
 * @Date 2019/4/10 18:38
 **/
const logger = require('../../core/xsyLog').logger('module_model_jar_update');
const xsyRequest = require('../../core/xsyRequest');
const loginUtils = require('../../utils/loginUtils');
const commonUtils = require('../../utils/commonUtils');
const environmentUtils = require('../../utils/environmentUtils');
const fs = require("fs");
const path = require("path");
const inquirer = require('inquirer');
const colors = require('colors');
const request = require('request');

function main() {
    commonUtils.get_project_path(process.cwd(), function () {
        const promptList = [{
            type: 'confirm',
            message: 'Long update time,continue or not?',
            name: 'is_agree',
            default: true
        }];

        inquirer.prompt(promptList).then(answers => {
            if (answers.is_agree) {
                console.log("Updating...".gray);
                update_model(function () {
                    console.log("Success".green);
                })
            }
        })
    });
}

function update_model(callback) {
    commonUtils.get_project_path(process.cwd(), function (projectPath) {
        xsyRequest({
            url: '/rest/metadata/v2.0/scripts/packages/model/jar',
            method: 'POST'
        }, function (error, response, body) {
            if (body.code === "200") {
                let modelStream = fs.createWriteStream(path.join(projectPath, "lib", "model.jar"));
                request(body.data.records).pipe(modelStream).on('close', callback);
            } else {
                console.log(JSON.stringify(body).red);
                process.exit(1);
            }
        });
    });
}


exports.main = main;
