#!/usr/bin/env node
/**
 * @ClassName pull
 * @Description TODO
 * @Author wangtx@xiaoshouyi.com
 * @Date 2019/4/10 18:38
 **/
const logger = require('../../core/xsyLog').logger('module_script_pull');
const xsyRequest = require('../../core/xsyRequest');
const loginUtils = require('../../utils/loginUtils');
const commonUtils = require('../../utils/commonUtils');
const fs = require("fs");
const path = require("path");
const inquirer = require('inquirer');
const unzip = require("unzip");
const colors = require('colors');
const request = require('request');

let projectPath = "";
let packageName = "";

function main() {
    download_remote_source(function () {
        const promptList = [{
            type: 'confirm',
            message: 'For the same file,remote will cover local,continue or not?',
            name: 'is_agree',
            default: true
        }];

        inquirer.prompt(promptList).then(answers => {
            if (answers.is_agree) {
                fs.createReadStream(path.join(projectPath, packageName + ".zip")).pipe(unzip.Extract({path: path.join(projectPath, "src")}));
                console.log("Success".green);
            }
            fs.unlink(path.join(projectPath, packageName + ".zip"), function (error) {
            });
        })
    });
}

function download_remote_source(callback) {
    commonUtils.get_project_path(process.cwd(), function (projectPath) {
        commonUtils.get_xsy_value_by_key("packageName", function (cPackageName) {
            packageName = cPackageName;
            xsyRequest({
                url: '/rest/metadata/v2.0/scripts/packages?packageName=' + packageName,
                method: 'GET'
            }, function (error, response, body) {
                if (body.data == null || body.data.records == null || body.data.records.uploadFile === null) {
                    console.log("this package is not exist on remote".red);
                } else {
                    let modelStream = fs.createWriteStream(path.join(projectPath, packageName + ".zip"));
                    request(body.data.records.uploadFile).pipe(modelStream).on('close', callback);
                }
            });
        });
    });
}

exports.main = main;
